/*!

init the dfrobot DF1201S mp3 player to the settings
expected by the gear auto-extend firmware:

- no startup msg
- baudrate 19200  (note - audio player must be powered off/on for this to take effect )
- volume 20
- playmode 3 

*/


#include <DFRobot_DF1201S.h>
#include <SoftwareSerial.h>

SoftwareSerial DF1201SSerial(8, 9);  //RX  TX

DFRobot_DF1201S DF1201S;

bool mp3PlayerInit = false;

void setup(void){
  Serial.begin(115200);
  /* try to init at baud rate 115200 */
  DF1201SSerial.begin(115200);
  mp3PlayerInit = false;
  for (int i = 0; i < 10 ; i++)
  {
    Serial.println("Trying to start at default baud rate of 115200..");
    if (DF1201S.begin(DF1201SSerial))
    {
      Serial.println("Success! Setting Gear Auto-extend defaults...");

      /*Set volume to 20*/
      DF1201S.setVol(/*VOL = */20);
      Serial.print("VOL:");
      /*Get volume*/
      Serial.println(DF1201S.getVol());
      /*Enter music mode*/
      DF1201S.switchFunction(DF1201S.MUSIC);
      /*Wait for the end of the prompt tone */
      delay(2000);
       /*Set playback mode to "SINGLE "song" only"*/
      DF1201S.setPlayMode(DF1201S.SINGLE);
      Serial.print("PlayMode:");
      /*Get playback mode*/
      Serial.println(DF1201S.getPlayMode());
  
      //Turn off the prompt tone (Power-down save) 
      DF1201S.setPrompt(false);
      // Set the default baud rate 
      DF1201S.setBaudRate(19200);
      
      Serial.println("MP3 Player setup is complete:");
      Serial.println("Restart required");
      break;
    }
  }  /* end for */
  
  Serial.println("Unable to communicate at 115200 baud, trying 19200...");
  DF1201SSerial.begin(19200);
  /* if mp3Player is already inited try to start at 19200 baud */
  for (int i = 0; i < 10; i++)
  {
  
    if (DF1201S.begin(DF1201SSerial))
    {
      Serial.println("Success!");
      Serial.print("VOL:");
      /*Get volume*/
      Serial.println(DF1201S.getVol());

      Serial.print("PlayMode:");
      /*Get playback mode*/
      Serial.println(DF1201S.getPlayMode());
      
      mp3PlayerInit = true;
      break;
    }
  }
  if (!mp3PlayerInit)
  {
    Serial.println("unable to initialize the mp3 player module - check connections");
  }  
}

void loop(){
  if (mp3PlayerInit)
  
  {
     DF1201S.setPlayMode(DF1201S.ALLCYCLE);
     DF1201S.enableAMP();
     DF1201S.start();
     delay(3000);
     DF1201S.pause();
     delay(3000);
     DF1201S.next(); 
     delay(3000);  

  }   
  
}
